function dlgEditODS()
{
	var baseParams_ = {
		showScope    : true,
		showMasks    : true,
		enableNext   : false,
		title        : _res('DLG_ODS_TITLE'),
		innerTitle   : _res('DLG_ODS_EDIT')
	};

	var impls_ = {
		odsInclude : { params : $.extend(true, { showSettings : true },  baseParams_) },
		odsExclude : { params : $.extend(true, { showSettings : false }, baseParams_) },
		rtpInclude : { params : $.extend(true, { showSettings : true,  showUsers : true }, baseParams_) },
		rtpExclude : { params : $.extend(true, { showSettings : false, showUsers : true }, baseParams_) }
	};

	function getImpl(name)
	{
		if(typeof(impls_[name].data) === 'undefined')
			impls_[name].data = new baseDlg(impls_[name].params);

		return impls_[name].data;
	}

	var self_ = this;

	function setupImpl(area)
	{
		var isRTP = (typeof(area.AccessUser) !== 'undefined');
		var isExclude = (typeof(area.ScanSettings) === 'undefined');
		if(isRTP)
			self_.impl_ = isExclude ? getImpl('rtpExclude') : getImpl('rtpInclude');
		else
			self_.impl_ = isExclude ? getImpl('odsExclude') : getImpl('odsInclude');

		self_.impl_.isRTP     = isRTP;
		self_.impl_.isExclude = isExclude;
	}

	this.openScopeTab = function(area, onOk)
	{
		setupImpl(area);
		this.__open('scopeTabNum_', area, onOk);
	}
	this.openSettingsTab = function(area, onOk)
	{
		setupImpl(area);
		this.__open('settingsTabNum_', area, onOk);
	}
	this.openMasksTab = function(area, onOk)
	{
		setupImpl(area);
		this.__open('masksTabNum_', area, onOk);
	}
	this.openUsersTab = function(area, onOk)
	{
		setupImpl(area);
		this.__open('usersTabNum_', area, onOk);
	}
	this.__open = function(numTab, area, onOk)
	{
		var changed_ = {};
		var params = {};
		params.includeObjects = area.AreaMask;
		if(!self_.impl_.isExclude) {
			params.scanSettings      = area.ScanSettings;
			params.excludeObjects    = area.ScanSettings.ExcludeMasks;
			params.excludeThreats    = area.ScanSettings.ExcludeThreats;
			params.useExcludeObjects = area.ScanSettings.UseExcludeMasks;
			params.useExcludeThreats = area.ScanSettings.UseExcludeThreats;
		}
		params.areaDesc   = area.AreaDesc;
		params.areaPath   = area.AreaPath.Path;
		params.areaFSType = area.AreaPath.FSType;
		params.areaFSName = area.AreaPath.FSName;

		if(self_.impl_.isRTP) {
			params.users    = area.AccessUser.UserName;
			params.groups   = area.AccessUser.UserGroup;
			params.useUsers = area.UseAccessUser;
		}

		params.settingsChanged = function(params)
		{
			changed_.ScanSettings      = params.scanSettings;
			changed_.AreaMask          = params.includeObjects;
			changed_.ExcludeMasks      = params.excludeObjects;
			changed_.ExcludeThreats    = params.excludeThreats;
			changed_.UseExcludeMasks   = params.useExcludeObjects;
			changed_.UseExcludeThreats = params.useExcludeThreats;
			changed_.AreaDesc = params.areaDesc;
			changed_.AreaPath = {
				Path   : params.areaPath,
				FSType : params.areaFSType,
				FSName : params.areaFSName
			};
			if(self_.impl_.isRTP)
			{
				changed_.AccessUser = {
					UserName  : params.users,
					UserGroup : params.groups
				};
				changed_.UseAccessUser = params.useUsers;
			}
		}
		params.okClicked = function(callback){

			if(typeof(changed_.AreaMask) !== 'undefined')
			{
				area.AreaMask                       = changed_.AreaMask;

				if(!self_.impl_.isExclude) {
					area.ScanSettings                   = changed_.ScanSettings;
					area.ScanSettings.ExcludeMasks      = changed_.ExcludeMasks;
					area.ScanSettings.ExcludeThreats    = changed_.ExcludeThreats;
					area.ScanSettings.UseExcludeMasks   = changed_.UseExcludeMasks;
					area.ScanSettings.UseExcludeThreats = changed_.UseExcludeThreats;
				}
				area.AreaPath = changed_.AreaPath;
				area.AreaDesc = changed_.AreaDesc;

				if(self_.impl_.isRTP)
				{
					area.AccessUser    = changed_.AccessUser;
					area.UseAccessUser = changed_.UseAccessUser;
				}
				editTask.setSettingsTaskChange();
			}
			callback();
			onOk();
		};

		self_.impl_.scanScopeModel_.use_ods_seclevel = function()
		{
			return !self_.impl_.isRTP;
		}

		$.extend(params, { activeTab:numTab });

		self_.impl_.open(params);

		//changeCustomAction.voDialog
	}

	this.close = function()
	{
		self_.impl_.close();
	}
}