ic.connectionActive = true;
ic.connectionLostId = 0;

function isKLUFProtocolError(data)
{
	return (data.errorMsg &&
		(data.errorMsg.indexOf('KLUF protocol error') > -1));
}

// Connection error handler
ic.errorHandlers.push(function(data, $errorBox){
	if(data.errorMsg &&
		((data.errorMsg.indexOf('HTTP Connection error') > -1) ||
		 (data.errorMsg.search(/Response:\s+Status:\s+parsererror/) > -1) ||
		 (data.errorMsg.indexOf("Connection error : connect()") > -1) ||
		 (data.errorMsg.search(/Recv()\s+error/) > -1)))
	{
		if(ic.connectionActive) {
			ic.connectionLostId++;
			ic.connectionActive = false;
		}

		ic.__connectionErrorHandlers.each(function(func){
			func(ic.connectionLostId);
		})
		return true;
	}
	else if((false == ic.connectionActive) && !isKLUFProtocolError(data)) {
		ic.__connectionRestoredHandlers.each(function(func){
			func(ic.connectionLostId);
		})
		ic.connectionActive = true;
	}
	return false;
})

// Unregister application
ic.errorHandlers.push(function(data, $errorBox){
	if(data.errorMsg &&
		(data.errorMsg.indexOf("Couldn't get bussiness logic address from supervisor") > -1))
	{
		ic.errorViewAppend(_res('STOPPED_APP_ERROR'), $errorBox);
		return true;
	}
	return false;
})

// Timeout or empty response
// ic.errorHandlers.push(function(data, $errorBox){
// 	if(data.errorMsg &&
// 		(data.errorMsg.search(/Response:\s+Status:\s+parsererror/) > -1))
// 	{
// 		ic.errorViewAppend(_res('TIMEOUT_OR_EMPTY_RESPONSE_ERROR'), $errorBox);
// 		return true;
// 	}
// 	return false;
// })

// Product connection error
// ic.errorHandlers.push(function(data, $errorBox){
// 	if(data.errorMsg &&
// 		((data.errorMsg.indexOf("Connection error : connect()") > -1) ||
// 		 (data.errorMsg.search(/Recv()\s+error/) > -1)))
// 	{
// 		ic.errorViewAppend(_res('PRODUCT_CONNECTION_ERROR'), $errorBox);
// 		return true;
// 	}
// 	return false;
// })

// Protocol error
ic.errorHandlers.push(function(data, $errorBox){
	if(isKLUFProtocolError(data))
	{
		if(ic.connectionActive)
			ic.errorViewAppend(_res('PROTOCOL_ERROR'), $errorBox);
		return true;
	}
	return false;
})

// license error
ic.errorHandlers.push(function(data, $errorBox){
	if(data.errorMsg && (data.errorMsg.indexOf("signature of license key is invalid") > -1))
	{
		ic.errorViewAppend(_res('LABEL_SIGNATURE_LICENSE_KEY_INVALID'), $errorBox);
		return true;
	}
	return false;
})
