
function actionsPage_drawActionsOnVerdict()
{
	for(var verdict in ic.VerdictTypeView)
	{
		$('#actionsTable')
			.append(tpl.evaluate({
				'verdict': verdict,
				'verdictLocalized': _res('TSA_LABEL_'+verdict)
			}));
		actionsPage_clearAdvOptions(verdict);
	}
}
function actionsPage_clearActionsOnVerdict()
{
	$('#actionsTable tr:has(:input[id^=adv_cb_])').remove()
}

function actionsPage_queryFirstSelect(verdict)
{
	return '#actionsTable #adv_act_' + verdict;
}

// sets interfaces in valid state for  'Infected' and 'Suspicious' actions
function actionsPage_setMainActions(settings, onChangeClbk)
{
	var desc = [
		[ '#action_Infected',          'InfectedFirstAction' ],
		[ '#second_action_Infected',   'InfectedSecondAction' ],
		[ '#action_Suspicious',        'SuspiciousFirstAction' ],
		[ '#second_action_Suspicious', 'SuspiciousSecondAction' ]
	];
	for(var i = 0; i < desc.length; i+=2)
	{
		var domId = desc[i][0]; // DOM element id
		var sprop1 = desc[i][1]; // Settings property
		var sprop2 = desc[i + 1][1]; // Settings property

		properties_.find(domId)
			.val( '' + settings[sprop1] + settings[sprop2])
			.attr({'ic_sprop1':sprop1, 'ic_sprop2': sprop2})
			.change(function(){
				settings[ $(this).attr('ic_sprop1') ] = $(this).val().charAt(0);
				settings[ $(this).attr('ic_sprop2') ] = $(this).val().charAt(1);
				onChangeClbk();
			})
	}
}

function actionsPage_drawAdvOptions(verdict, advActionObject)
{
	$(actionsPage_queryFirstSelect(verdict))
		.empty()
		.append(ic.VerdictTypeView[verdict] == ic.VerdictType.Virware
			? virWareOptionsHtml
			: otherWareOptionsHtml
		)
		.css({'visibility' : 'visible'});
	//	.width(actionsSelectWidth);

	$(actionsPage_queryFirstSelect(verdict))
		.val('' + advActionObject.FirstAction + advActionObject.SecondAction)
		.change(function(){
		 	advActionObject.FirstAction = $(this).val().charAt(0)
			advActionObject.SecondAction = $(this).val().charAt(1)
		 	editTask.setSettingsTaskChange()
		})

	$('#actionsTable #adv_cb_' + verdict).attr('checked', true);
}
function actionsPage_clearAdvOptions(verdict)
{
	$(actionsPage_queryFirstSelect(verdict)).css({'visibility' : 'hidden'}).empty()
}
