function generalPage_onChangeTaskState(response)
{
	var previousState = $('#status').attr('ic_state');

	if(response.BLError) {
		$('#errorBox').show();
		$('#errorBox').html('<br />' + response.errorMsg);
		if(editTask.taskInfo.id)
			ic.getTask(editTask.taskInfo.id, function(resp){ generalPage_onChangeTaskState(resp) });
	}
	else if(!ic.ajaxError(response)) {
		g_taskId = response.id;
		generalPage_updateSummaryTable(response)

		//TasksListPage_startStopCallback(response);

		var clz = response.clazz;

		if(clz == ic.TaskClass.ODS) {
			table_changeTaskScanned(response);
			table_changeTaskDetected(response);
			TasksListPage_table_changeTaskSuspicious(response);
		}

		if((clz == ic.TaskClass.ODS) || (clz == ic.TaskClass.Update)
				|| (clz == ic.TaskClass.QS))
			TasksListPage_table_changeTaskState(response);

		if(statEnabled)
			statPage_updateStatValues(response);

		$('#status').attr('ic_state', response.state);
	}

	delay = 5000;

	if(	(response.state === ic.TaskState.Starting)   ||
		(response.state === ic.TaskState.Stopping)   ||
		(response.state === ic.TaskState.Suspending) ||
		(response.state === ic.TaskState.Resuming))
		delay = 1000; // transitional state

	if((response.clazz === ic.TaskClass.ODS) && (response.state === ic.TaskState.Started))
		delay = 2000; // narrowly monitor active ODS task

	if((response.clazz === ic.TaskClass.OAS)
		&& (previousState != undefined)
		&& (previousState != response.state))
	{
		summaryListFunc.response.rtp.state = response.state;
		summary_draw();
	}

	setTimeout(generalPage_getSummary, delay);
}
function generalPage_startTask(taskId)
{
	$('#errorBox').empty();
	generalPage_updateSummaryTable({state : ic.TaskState.Starting});
	ic.startTask(taskId, generalPage_onChangeTaskState);
}
function generalPage_pauseTask(taskId)
{
	$('#errorBox').empty();
	generalPage_updateSummaryTable({state : ic.TaskState.Suspending});
	ic.suspendTask(taskId, generalPage_onChangeTaskState);
}
function generalPage_resumeTask(taskId)
{
	$('#errorBox').empty();
	generalPage_updateSummaryTable({state : ic.TaskState.Resuming});
	ic.resumeTask(taskId, generalPage_onChangeTaskState);
}
function generalPage_stopTask(taskId)
{
	$('#errorBox').empty();
	generalPage_updateSummaryTable({state : ic.TaskState.Stopping});
	ic.stopTask(taskId, generalPage_onChangeTaskState);
}
function generalPage_getStatusResource(state)
{
	switch(state)
	{
		case ic.TaskState.Stopped   : return 'STATUS_RTP_STOPPED';
		case ic.TaskState.Stopping  : return 'STATUS_RTP_STOPPING';
		case ic.TaskState.Started   : return 'STATUS_RTP_STARTED';
		case ic.TaskState.Starting  : return 'STATUS_RTP_STARTING';
		case ic.TaskState.Suspended : return 'STATUS_RTP_SUSPENDED';
		case ic.TaskState.Suspending: return 'STATUS_RTP_SUSPENDING';
		case ic.TaskState.Resumed   : return 'STATUS_RTP_RESUMED';
		case ic.TaskState.Resuming  : return 'STATUS_RTP_RESUMING';
		case ic.TaskState.Failed    : return 'STATUS_RTP_FAILED';
	}
	return 'STATUS_RTP_UNKNOWN';
}

function generalPage_pauseStopLinks()
{
	stopTaskLink =
		'<a href="javascript:generalPage_stopTask(#{id})"' +
		' class="blue res:COMMAND_STOP_TASK"></a>';

	// No 'pause' link for Update task
	if(misc_describeTaskByLocation().clazz == ic.TaskClass.Update)
		return stopTaskLink;

	return (
		'<a href="javascript:generalPage_pauseTask(#{id})"' +
		' class="blue res:COMMAND_PAUSE_TASK"></a>' +
		'<span class="mrg_v6">|</span>' + stopTaskLink );
}

function generalPage_getStatusAddonTemplate(state)
{
	switch(state)
	{
		case ic.TaskState.Stopped:
		case ic.TaskState.Failed:
			return '<a href="javascript:generalPage_startTask(#{id})" class="blue res:COMMAND_START_TASK"></a>';

		case ic.TaskState.Suspended:
			return '<a href="javascript:generalPage_resumeTask(#{id})" class="blue res:COMMAND_RESUME_TASK"></a>';

		case ic.TaskState.Started:
		case ic.TaskState.Resumed:
			return generalPage_pauseStopLinks();
	}
	return '';
}

function generalPage_updateSummaryTable(response)
{
	$table  = $('#summaryTable');
	$status = $table.find('#status');
	$table.find('#tr_status').show();

	resid  = generalPage_getStatusResource(response.state);

	$status.html(_res(resid));
	if(response.clazz == ic.TaskClass.OAS) {
		addon_ = generalPage_getStatusAddonTemplate(response.state);
		$table.find('#addon').updateHtml(new Template(addon_).evaluate(response));
	}

	if(	(response.state == ic.TaskState.Started) ||
		(response.state == ic.TaskState.Resumed))
	{
		$table.find('#tr_startTime').show();
		$table.find('#td_startTime').updateHtml(misc_formatTime(response.startTime));
	}
	else
		$table.find('#tr_startTime').hide();
}

function generalPage_getSummary()
{
	if(getSummaryRunning === true)
		return;

	if((editTask.taskInfo == null) || !editTask.taskInfo.id) {
		setTimeout(generalPage_getSummary, 100);
		return;
	}

	g_taskId = editTask.taskInfo.id;
	getSummaryRunning = true;
	ic.getTask(g_taskId, function(resp){
		generalPage_onChangeTaskState(resp);
		getSummaryRunning = false;
	});
}
function generalPage_setRTPProtMode()
{
//	Protection Type:
//	Full		- 1
//	KernelOnly	- 2
//	SambaOnly	- 3
	function showProtectionType()
	{
		var $rtpMode = $("#rtp_protect_type");
		if( $rtpMode.length == 0 )
			return;

		var $totalScanners = $rtpMode.find('#rtp_total_scanners').unbind();
		$totalScanners.val(editTask.SettingsTask.TotalScanners);
		misc_setupSizeCorrector( $totalScanners, {
			parseFunc : parseInt,
			min       : 4,
			max       : 256
		});
		$totalScanners.change(function(){ $(this).trigger('fastChange'); }).fastChange(function(){
				editTask.SettingsTask.TotalScanners = $totalScanners.i_val();
				editTask.setSettingsTaskChange();
			});

		var selectedMode = parseInt(editTask.SettingsTask.ProtectionType);

		$rtpMode.find("#rtp_prot_mode"+selectedMode).attr('checked', true);
		for(var i = 1; i <= 3; i++)
		{
			$rtpMode.find("#rtp_prot_mode"+i).click(function(){
				var new_val = parseInt(this.value);
				if(editTask.SettingsTask.ProtectionType != new_val)
				{
					editTask.SettingsTask.ProtectionType = new_val;
					editTask.setSettingsTaskChange();
				}
			});
		}
		taskSettings_addRevertFunc(showProtectionType);
	}
	misc_waitFor(editTask_SettingsTaskCompleted, showProtectionType);
}

function generalPage_setODSPriority()
{
	function showScanPriority()
	{
		var $ns  = $('#ods_priority');
		if($ns.length == 0)
			return;

		var val  = editTask.SettingsTask.ScanPriority;
		var sval = getObjectKeyByValue(
			ic.ScanPriority,
			val,
			ic.ScanPriority.Default);

		$ns.find('#' + sval).attr('checked', true);
		$ns.find(':radio').click(function(){
			$ns.find(':radio').attr('checked', false);
			$(this).attr('checked', true);
			var newval = ic.ScanPriority[this.id];
			if( editTask.SettingsTask.ScanPriority != newval )
			{
				editTask.SettingsTask.ScanPriority = newval;
				editTask.setSettingsTaskChange();
			}
		})
		taskSettings_addRevertFunc(showScanPriority);
	}
	misc_waitFor(editTask_SettingsTaskCompleted, showScanPriority);
}

function generalPage_toggleStatLevel()
{
	var $table = $('#statTable');
	if($table.length == 0)
		return;

	var $fullstat = $table.find('tr.full-stat');
	if( $fullstat.length > 0 )
	{
		$('#toggleStatLink').html(_res('TASK_STAT_FULL_STAT_LINK'));
		$fullStatContent = $('<div />').append($fullstat);
		ic.storage.save('full_stat', '0');
	}
	else
	{
		$('#toggleStatLink').html(_res('TASK_STAT_SHORT_STAT_LINK'));
		$table.find('#toggleStatLinkRow').before($fullStatContent.html());
		statPage_updateStatValues($table.get(0).lastStat);
		ic.storage.save('full_stat', '1');
	}
}

function generalPage_connectionLost()
{
	$('#statTable,#tr_status,#tr_startTime').hide();
	$('#tr_infoNotAvailable').show();
}

function generalPage_connectionRestored()
{
	$('#tr_infoNotAvailable').hide();
	generalPage_getSummary();
//	if(statEnabled)
//		statPage_getStat();
}

ic.registerConnectionErrorHandler(function(){
	$('#rtpGeneralPageMarker').trigger('connLost'); // FIXME: use just .length
})

ic.registerConnectionRestoredHandler(function(){
	$('#rtpGeneralPageMarker').trigger('connRestored'); // FIXME: use just .length
})
