function statPage_updateStatValues(response)
{
	if(typeof(response) === 'undefined')
		return;

	$table = $('#statTable');
	$table.show();

	desc = describeTaskByLocation();
	for(prop in response)
	{
		$tr = $table.find('#' + prop);
		if(($tr.length > 0) && (!$tr.attr('ic_statItemValue')
			|| ($tr.attr('ic_statItemValue') != response[prop])))
		{
			$tr.attr('ic_statItemValue', response[prop]);
			$tr.find('#statItemValue').html(''+response[prop]);
		}
	}

	[ 'infected_objects'
	, 'threats_found'
	, 'suspicious_objects' ].each(function(field){
		if(response[field] > 0)
			$table.find('> tbody > tr#' + field + ' > td:not(.red)').addClass('red');
		else
			$table.find('> tbody > tr#' + field + ' > td.red').removeClass('red');
	});
}

function statPage_updateStat(response)
{
	if(ic.ajaxError(response))
		return;

	$table = $('#statTable');
	if($table.length == 0)
		return;

	$table.get(0).lastStat = response;
	statPage_updateStatValues(response);

	setTimeout(statPage_getStat, 2000);
}

function statPage_taskIdAvailable()
{
	return ((typeof(g_taskId) != 'undefined') && (g_taskId != null));
}

function statPage_getStatImpl()
{
	var initHref = window.location.hash;
	ic.getTaskStatistics(g_taskId, function(response){
		if(initHref == window.location.hash)
			statPage_updateStat(response);
	});
}

function statPage_getStat()
{
	misc_waitFor(statPage_taskIdAvailable, statPage_getStatImpl);
}
