var RTPTabs =
[
	["RTP_TAB_GENERAL",    "rtp_general.html", ""],
	["RTP_TAB_RUN_MODE",   "schedule.html",    "__schedule__"],
	["RTP_TAB_SCAN_SCOPE", "rtp_scope.html",   "__scope__"],
	["RTP_TAB_EXCLUDES",   "rtp_scope.html",   "__excludescope__"],
	["RTP_TAB_PROTMODE",   "rtp_protmode.html","__protmode__"]
];

var ODSTabs =
[
	["RTP_TAB_GENERAL",    "rtp_general.html",  ""],
	["RTP_TAB_RUN_MODE",   "schedule.html",     "__schedule__"],
	["ODS_TAB_SCAN_SCOPE", "rtp_scope.html",    "__scope__"],
	["ODS_TAB_EXCLUDES",   "rtp_scope.html",    "__excludescope__"],
	["ODS_TAB_PRIORITY",   "ods_priority.html", "__priority__"]
];

var QSTabs =
[
	["RTP_TAB_GENERAL",    "rtp_general.html", ""],
	["RTP_TAB_RUN_MODE",   "schedule.html",    "__schedule__"]
];

var UpdateTabs =
[
	["TAB_GENERAL"				, "rtp_general.html"		,""],
	["TAB_RUN_MODE"				, "schedule.html"			,"__schedule__"],
	["TAB_CONNECTION"			, "update_connection.html"	,"__connection_settings__"],
	["TAB_UPDATE_SOURCE"		, "update_source.html"		,"__source__"],
	["TAB_UPDATE_RETRANSLATE"	, "update_retranslate.html"	,"__retranslate__"]
];

function taskSettings_getTabs()
{
	var desc = misc_describeTaskByLocation();
	switch(desc.clazz)
	{
		case ic.TaskClass.Update : return UpdateTabs;
		case ic.TaskClass.OAS    : return RTPTabs;
		case ic.TaskClass.ODS    : return ODSTabs;
		case ic.TaskClass.QS     : return QSTabs;
	}
	return [];
}

function taskSettings_findTabByHref()
{
	var tabs = taskSettings_getTabs();
	var loc  = window.location.hash;
	for(var i = 1; i < tabs.length; i++){
		var s = tabs[i][2];
		if((s.length > 0) && (loc.indexOf('/' + s) > -1))
			return i;
	}
	return 0;
}

function taskSettings_baserefImpl(a)
{
	var h = window.location.hash;
	for(var i = 0; i < a.length; i++)
	{
		var pos = h.search(new RegExp('/' + a[i] + '$'));
		if(pos > -1)
			return h.substring(0, pos);

		var pos = h.search(new RegExp('/' + a[i] + '/'));
		if(pos > -1)
			return h.substring(0, pos);
	}
	return h;
}

function taskSettings_baseref()
{
	var tabs = taskSettings_getTabs();
	var a = [];
	for(i = 0; i < tabs.length; i++)
		a[a.length] = tabs[i][2];

	return taskSettings_baserefImpl(a);
}

function taskSettings_selectTabByHref()
{
	var num = taskSettings_findTabByHref();

	if(num > 0)
		$('#settingsContentTable td:first').addClass('l').removeClass('l_no')
	else
		$('#settingsContentTable td:first').addClass('l_no').removeClass('l')

	$('#tablink_n [id^=tablink]').removeClass('active');
	$('#tablink' + num).addClass('active');

	var tabs = taskSettings_getTabs();

	$('#view_data_info').loadCache('pages/settingsTask/' + tabs[num][1]);
}

var taskSettings_tabTitle =
	'<td>'+
	'<a href="#" title="General" id="tablink0">'+
	'<div class="box"><div class="l"></div>'+
	'<div class="c">General</div>'+
	'<div class="r"></div></div></a>'+
	'</td>'

function taskSettings_initializeTabs()
{
	var tabs     = taskSettings_getTabs();
	var _baseref = taskSettings_baseref();

	for(var i = 0; i < tabs.length; i++)
	{
		if( $('#tablink_n #tablink' + i).length > 0)
			continue;

		var res = _res(tabs[i][0]);
		var href_ = _baseref;
		if(tabs[i][2].length > 0)
			href_ += '/' + tabs[i][2];

		var $title = $(taskSettings_tabTitle);
		$title.find('div.c').html(res);
		$title.find('a')
			.attr('href',  href_)
			.attr('title', res)
			.attr('id',   'tablink' + i)
			.icHistory(function(){
				window.location.href = this.href;
				if( $('#tablink_n #' + this.id).length > 0 )
					taskSettings_selectTabByHref();
				else
					taskSettings_onload();
			});
		$('#tablink_n').append($title);
	}
}

function taskSettings_addRevertFunc(func)
{
	$('#b_RevertSettings').each(function(){
		this.revertFunctions = this.revertFunctions || [];
		this.revertFunctions[this.revertFunctions.length] = func;
	})
}

function taskSettings_doRevert()
{
	$('#settingsErrorBox,#settingsStatusBox').html('');

	$('#b_RevertSettings').each(function(){
		var a = this.revertFunctions;
		this.revertFunctions = [];
		for(var i = 0; i < a.length; a[i++]());
	})
}

function taskSettings_clearRevertFunctions()
{
	$('#b_RevertSettings').each(function(){
		this.revertFunctions = [];
	})
}

function taskSettings_onload()
{
	taskSettings_clearRevertFunctions();

	taskDesc = describeTaskByLocation();
	g_taskId = editTask.taskInfo.id

	taskSettings_initializeTabs();
	taskSettings_selectTabByHref();

	editTask.initButtonSaveEnabled()
	$('#b_SaveSettings').click(function(){
		editTask.saveSettings()
	});
	$('#b_RevertSettings').click(taskSettings_doRevert);

	function __editTaskRevert() {
		editTask.revertSettings();
		taskSettings_addRevertFunc(__editTaskRevert);
	}
	taskSettings_addRevertFunc(__editTaskRevert);
}

function taskSettings_proxyDisabled()
{
	if ($('#uc_proxy_kl_server').attr("checked")  || $('#uc_proxy_for_custom').attr("checked"))
	{
		$('#uc_address_label').removeClass("grey")
		$('#uc_address').attr("disabled","")
		$('#uc_port_label').removeClass("grey")
		$('#uc_port').attr("disabled","")
		$('#uc_bypass_label').removeClass("grey")
		$('#uc_bypass').attr("disabled","")
		$('#uc_auth_required_label').removeClass("grey")
		$('#uc_auth_required').attr("disabled","")
		taskSettings_setLoginPasswordDisabled($('#uc_auth_required').attr("checked"))
	}
	else {
		$('#uc_address_label').addClass("grey")
		$('#uc_address').attr("disabled","disabled")
		$('#uc_port_label').addClass("grey")
		$('#uc_port').attr("disabled","disabled")
		$('#uc_bypass_label').addClass("grey")
		$('#uc_bypass').attr("disabled","disabled")
		$('#uc_auth_required_label').addClass("grey")
		$('#uc_auth_required').attr("disabled","disabled")
		taskSettings_setLoginPasswordDisabled(false)
	}
}

function taskSettings_onUpdateSettingsGot()
{
	if( $('#uc_fp_passive').length == 0 )
		return;

	var obj = editTask.SettingsTask.CommonSettings;

	$('#uc_fp_passive').attr("checked",obj.UseFtpPassiveMode)
	$('#uc_fp_passive').click(function()
		{
			obj.UseFtpPassiveMode = $('#uc_fp_passive').attr("checked")
					setUpdateSettingsChange()
		})

	$('#uc_timeout').stepper({min:0,max:120,step:1,start:obj.ConnectionTimeout});
	$('#uc_timeout :text').val(obj.ConnectionTimeout);

	taskSettings_setStepperChange($('#uc_timeout'),function(val)
		{
			if (!val) val = 10
			obj.ConnectionTimeout = val
			setUpdateSettingsChange()
		})

	$('#uc_proxy_kl_server').attr("checked",obj.UseProxyForKLServers)
	$('#uc_proxy_kl_server').click(function()
		{
			taskSettings_proxyDisabled();
			obj.UseProxyForKLServers = $('#uc_proxy_kl_server').attr("checked");
			setUpdateSettingsChange();
		})

	$('#uc_proxy_for_custom').attr("checked",obj.UseProxyForCustomSources)
	$('#uc_proxy_for_custom').click(function()
		{
			taskSettings_proxyDisabled();
			obj.UseProxyForCustomSources = $('#uc_proxy_for_custom').attr("checked");
			setUpdateSettingsChange();
		})

	$('#uc_address').val(obj.ProxyServer)
	$('#uc_address').fastChange(function()
		{
			obj.ProxyServer = $('#uc_address').val()
			setUpdateSettingsChange()
		})

	$('#uc_port_div').stepper({min:1,max:65535,step:1,start:obj.ProxyPort})
	$('#uc_port_div :text').val(obj.ProxyPort);
	taskSettings_setStepperChange($('#uc_port_div'),function(val)
		{
			if (!val) val = 3128
			obj.ProxyPort = val
			setUpdateSettingsChange()
		})

	$('#uc_bypass').attr("checked",obj.ProxyBypassLocalAddresses)
	$('#uc_bypass').click(function()
		{
			obj.ProxyBypassLocalAddresses = $('#uc_bypass').attr("checked");
			setUpdateSettingsChange();
		})
	taskSettings_setAuthFunction(obj, 'uc_auth_required',0)

	switch (obj.ProxyAuthType)
	{
		case ic.ProxyAuthType.NotRequired:
			$('#uc_auth_required').attr("checked",false);
			break;
		default:
			$('#uc_auth_required').attr("checked",true);
			taskSettings_setLoginPasswordDisabled(true)
	}

	$('#uc_user').val(obj.ProxyAuthUser)
	$('#uc_user').fastChange(function()
		{
			obj.ProxyAuthUser = $('#uc_user').val()
			setUpdateSettingsChange()
		})
	$('#uc_password').val(obj.ProxyAuthPassword)
	$('#uc_password').fastChange(function()
		{
			obj.ProxyAuthPassword = $('#uc_password').val()
			setUpdateSettingsChange()
		})
	taskSettings_proxyDisabled();
	taskSettings_addRevertFunc(taskSettings_onUpdateSettingsGot);
}

function taskSettings_setAuthFunction(obj, id, value)
{
	$('#'+id).click(function(){
		taskSettings_setLoginPasswordDisabled($(this).attr("checked"))
		if($(this).attr("checked"))
			obj.ProxyAuthType = ic.ProxyAuthType.Plain;
		else
			obj.ProxyAuthType = ic.ProxyAuthType.NotRequired;

		setUpdateSettingsChange()
	})
}

function taskSettings_setStepperChange(el, func)
{
	el.find('input[type="text"]').fastChange(function(){
		val_str = el.find('input[type="text"]').val()
		if (val_str == '')
			val = 0;
		else {
			val = parseInt(val_str)
			if(isNaN(val)) {
				val = 0;
				el.find('input[type="text"]').val("0");
			}
		}
		func(val)
	})
}

function taskSettings_setLoginPasswordDisabled(val)
{
	if (!val){
		$('#uc_user_label').addClass("grey")
		$('#uc_password_label').addClass("grey")
		$('#uc_user').attr("disabled","disabled")
		$('#uc_password').attr("disabled","disabled")

	}
	else {
		$('#uc_user_label').removeClass()
		$('#uc_password_label').removeClass()
		$('#uc_user').attr("disabled","")
		$('#uc_password').attr("disabled","")
	}
}

function setUpdateSettingsChange()
{
	editTask.setSettingsTaskChange()
}
