PagesCache =
{
	cache_   : {},
	pending_ : {},

	draw : function( $elem, url, callback )
	{
		var _data = this.cache_[url];

		$elem.html(_data[0]);
		if(jQuery.isFunction(callback))
			setTimeout(function(){ callback.call($elem, _data[0], _data[1], _data[2]) });

	},

	load : function( $elem, url, callback )
	{
		function __onDataAvailable()
		{
			_self.draw( $elem, url, callback );
		}

		var _self = this;
		if(typeof(_self.cache_[url]) === 'undefined') // no page in cache
		{
			if(typeof(_self.pending_[url]) === 'undefined') {
				_self.pending_[url] = [];
				_self.fetch(url, function(responseText, status, result){
					var callbacks = _self.pending_[url];
					for(var i = 0; i < callbacks.length; i++)
						callbacks[i]();
					callbacks.length = 0;
				})
			}
			_self.pending_[url].push(__onDataAvailable);
		}
		else
			__onDataAvailable();
	},

	fetch : function( url, callback )
	{
		var _self = this;
		data = _self.cache_[url];
		if(data) {
			if(jQuery.isFunction(callback))
				callback(data[0], data[1], data[2]);

			return;
		}

		function onPageLoad(responseText, status, result){
			_self.cache_[url] = [ responseText, status, result ];
			callback(responseText, status, result);
		}
		jQuery.get(url, {}, onPageLoad, 'html');
	}
};

jQuery.fn.loadCache = function(url, callback)
{
	return this.each(function(){
		ic.loading.show();
		PagesCache.load( $(this), url, function(){
			if($.isFunction(callback))
				callback.apply(this, arguments);
			ic.loading.hide();
		});
	})
}

function preloadPages()
{
	return;

	var pages = // better to be sorted by priority
	[
		'settingsTask/rtp_settings.html',
		'settingsTask/rtp_general.html',
		'settingsTask/rtp_scope.html',
		'settingsTask/rtp_protmode.html',
		'settingsTask/ods_priority.html',
		'settingsTask/schedule.html',
		'settingsTask/rtp_stat.html',
		'settingsTask/scope_table.html',
		'settingsTask/product.html',

//		'settingsTask/rtp_edit_desc.html',
		'settingsTask/rtp_edit_path.html',
		'settingsTask/rtp_scan_objects.html',
		'settingsTask/rtp_sl_actions_.html',
		'settingsTask/rtp_sl_excludes_.html',
		'settingsTask/rtp_sl_perfomance_.html',
		'settingsTask/rtp_users_group_.html',

		'settingsTask/update_connection.html',
		'settingsTask/update_source.html',
		'settingsTask/update_retranslate.html',

		'q_adv_search.html',
		'q_simple_search.html',
		'logs_search.html',
		'reports_create_dlg.html',
		'reports_create_link.html',
		'task_create_link.html',
		'task_create_dlg.html',
		'exception.html'/*,

		'task_settings_dialog.html'*/
	];

	function preloadPage(num) {
		PagesCache.fetch('pages/' + pages[num], function(){
			if(++num < pages.length)
				setTimeout(function(){
					preloadPage(num);
				},
				200);
		});
	}
	preloadPage(0);
}
