function completeReportImpl(data)
{
	$('body').localize();

	var props = [
		'createdBy',
		'beginDate',
		'endDate',
		'scanned',
		'infe',
		'disinfe',
		'threats',
		'notCured',
		'threats',
		'quaMoved',
		'removedObjects',
		'scanErrors',
		'total',
		'suspicious',
		'corruptd',
		'riskware',
		'passProt'
	];

	for(var i = 0; i < props.length; i++) {
		var p = props[i];
		$('#' + p).html('' + data[p]);
	}

	document.title = data.reportName;

	function formatReportName(name)
	{
		if(name.length > 50)
			return '<a title="'
				+ misc_preparetoView(name) + '">'
				+ misc_preparetoView(name.substr(0, 50) + '...')
				+ '</a>'

		return misc_preparetoView(name);
	}

	$('#reportName').html(formatReportName(data.reportName));

	if(data.beginTime > 0)
		$('#beginTime').html(misc_formatTime(data.beginTime));
	else
		$('#beginTime').parent('tr').remove();

	if(data.endTime > 0)
		$('#endTime').html(misc_formatTime(data.endTime));
	else
		$('#endTime').parent('tr').remove();

	if(data.top10.length == 0)
		$('#top10Table').remove();
	else {
		var $tmpl  = $('#top10ItemTemplate');
		var tmpl   = $tmpl.html();
		var $tbody = $tmpl.parent('tbody');
		$tmpl.remove();

		for(var i = 0; i < data.top10.length; i++) {
			var item = data.top10[i];
			var perc = Math.floor(item.infe / data.top10Max * 100);
			var $elem = $('<tr>' + tmpl + '</tr>');

			$elem
				.find('#numInfected')
				.html(_res('REPORT_TOP10_INFECTED_FILES')
					.replace('#{NUM_INFECTED}', item.infe));

			$elem.find('#virusName').html(item.virusName);
			$elem.find('#percent').css('width', perc + '%');
			$elem.appendTo($tbody);
		}
		// print top10 here
	}
}

function completeReport(data)
{
	resources = new Resources();
	resources.onFileLoaded = function(file)
	{
		$('#langSelection').append('<option value="'
			+ file + '">'
			+ _res('LANG')
			+ '</option>');
		$('#langSelection > #dummyOption').remove();
	}

	resources.onLoadComplete = function()
	{
		var resfile = getCurrentResourceFile();
		Resource = this.data_[resfile];
		if( this.files_.length > 1 )
			$('#langSelection').change(setCurrentResourceFile).val(resfile);
		else
			$('#langSelection').hide();
		completeReportImpl(data);
	}
	resources.load();

	$('#a_xlsLink').attr('href',
		window.location.href.replace("printHTMLReport", "printXLSReport"));
	$('#a_pdfLink').attr('href',
		window.location.href.replace("printHTMLReport", "printPDFReport"));
}
