function StatusComponentPaint(key,color){
	this.key = key;
 	switch (color){
		case "red":
			this.bg = "w50 red_tab";
			this.title_font = "white_title";
			this.status_font = "red";
			this.status_id=0;
			break;
		case "yellow":
			this.bg = "w50 yellow_tab";
			this.title_font = "brown_title";
			this.status_font = "brown";
			this.status_id=1;
			break;
		case "green":
			this.bg = "w50 green_tab";
			this.title_font = "white_title";
			this.status_font = "green";
			this.status_id=2;
			break;
	}
}

function getStatusTaskAction(status)
{
	switch (status)
	{
		case ic.TaskState.Stopped:   return ["TASK_ACTION_RUN"]
		case ic.TaskState.Started:   return ["TASK_ACTION_PAUSE",   "TASK_ACTION_STOP"]
		case ic.TaskState.Suspended: return ["TASK_ACTION_RESUMED", "TASK_ACTION_STOP"]
		case ic.TaskState.Resumed:   return ["TASK_ACTION_PAUSE",   "TASK_ACTION_STOP"]
	}
	return [];
}
function getStatusTaskStatusBar(status)
{
	switch(status)
	{
		case ic.TaskState.Stopped:
		case ic.TaskState.Stopping:
		case ic.TaskState.Suspending:
		case ic.TaskState.Resuming:
		case ic.TaskState.Failed:
		case ic.TaskState.Starting: return false
		case ic.TaskState.Started:
		case ic.TaskState.Suspended:
		case ic.TaskState.Resumed:  return true
	}
}


function getStatusTaskInfo(status)
{
	switch (status.status)
	{
		case ic.TaskState.Stopped:    return ' ' + status.info;
		case ic.TaskState.Stopping:
		case ic.TaskState.Started:
		case ic.TaskState.Suspended:
		case ic.TaskState.Suspending:
		case ic.TaskState.Resumed:
		case ic.TaskState.Resuming:   return ' (' + status.info + '%)';
		case ic.TaskState.Failed:
		case ic.TaskState.Starting:   return ''
	}
}

function getStatusComponentPaintRTP(status)
{
	var status_str = generalPage_getStatusResource(status.state);
	switch (status.state){
		case ic.TaskState.Stopped:
		case ic.TaskState.Stopping:
		case ic.TaskState.Failed:
		case ic.TaskState.Suspended:
			return new StatusComponentPaint(status_str,"red")
		case ic.TaskState.Started:
		case ic.TaskState.Resumed:
			return new StatusComponentPaint(status_str,"green")
		case ic.TaskState.Resuming:
		case ic.TaskState.Starting:
		case ic.TaskState.Suspending:
			return new StatusComponentPaint(status_str,"yellow")
		default :
			return new StatusComponentPaint("STATUS_RTP_FAILED","red")
	}
}

function getStatusComponentPaintUpdate(status)
{
	switch(status)
	{
		case 1 : return new StatusComponentPaint("STATUS_UPDATE_OK","green")
		case 2 : return new StatusComponentPaint("STATUS_UPDATE_OLD","yellow")
		case 3 : return new StatusComponentPaint("STATUS_UPDATE_OLDEST","red")
	}
	return new StatusComponentPaint("STATUS_UPDATE_UNKNOWN","red");
}

function getStatusComponentPaintLicense(status)
{
	if(status.daysLeft === undefined )
		return new StatusComponentPaint("STATUS_LICENSE_NOT_INSTALLED","red")

	if(status.restriction!=1)
		return new StatusComponentPaint("BLERROR_LicenseError","red")

	if(status.daysLeft > 28)
		return new StatusComponentPaint("STATUS_LICENSE_OK","green")

	if(status.daysLeft >= 0 && status.restriction===1 )
		return new StatusComponentPaint("STATUS_LICENSE_SOON_EXPIRE","yellow")

	return new StatusComponentPaint("STATUS_LICENSE_EXPIRED","red")
}

function getStatusComponentPaintQuarantine(status)
{
	switch(status)
	{
		case STATUS_LICENSE_OK :
			return new StatusComponentPaint("STATUS_LICENSE_OK", "green");
		case STATUS_LICENSE_SOON_EXPIRE :
			return new StatusComponentPaint("STATUS_LICENSE_SOON_EXPIRE", "yellow");
		case STATUS_LICENSE_EXPIRED :
			return new StatusComponentPaint("STATUS_LICENSE_EXPIRED", "red");
	}
	return new StatusComponentPaint("STATUS_RTP_FAILED", "red");
}

function paintStatusComponentRTP(status)
{
	$('#table_rtp').show();

	status_paint = getStatusComponentPaintRTP(status);
	$("#status_rtp").attr('class', status_paint.bg);
	$("#title_rtp").attr('class', status_paint.title_font);
	$("#status_rtp_text").attr('class', status_paint.status_font);

	setLocalText("value_rtp_0",status_paint.key);
	if(status.scanned_objects !== undefined)
	{
		setText("value_rtp_1", status.scanned_objects + ' objects');
		setText("value_rtp_2", status.threats_found + '');
	}
}

function paintStatusComponentUpdate(status)
{
	$('#table_update').show();

	status_paint = getStatusComponentPaintUpdate(status.current_bases_state)

	$("#status_update").attr('class', status_paint.bg);
	$("#title_update").attr('class', status_paint.title_font);
	$("#status_update_text").attr('class', status_paint.status_font);

	setLocalText("value_update_0", status_paint.key);

	if(status.current_bases_state > 0)
	{
		setText("value_update_1", ic.timeToString(status.last_update_bases_date));
		setText("value_update_2", ic.timeToString(status.current_bases_date));
	}
}

function paintStatusComponentLicense(status)
{
	status_paint = getStatusComponentPaintLicense(status)

	$("#status_licence").attr('class', status_paint.bg);
	$("#title_license").attr('class', status_paint.title_font);
	$("#status_license_text").attr('class', status_paint.status_font);

	setLocalText("value_license_0", status_paint.key)

	var $sel = $('#tr_licenseExpires,#tr_licenseDaysRemains,#td_licenseStatusLabel');

	$('#tr_licenseStatusLabel').show();

	if(status.daysLeft !== undefined)
	{
		$sel.show();
		setText("value_license_1", ic.licenseDateToSring(status.expiration));
		setText("value_license_2", misc_getPluralForm(status.daysLeft, "PLURAL_DAYS_ARRAY_")+"")
	}
	else
		$sel.hide();
}

function paintStatusComponentQuarantine(status)
{
	if(status.qTotalObjects !== undefined)
	{
		var str = ""+status.qTotalObjects
		if (status.count_new > 0)
			str += "(" + status.count_new + _res("LABEL_NEW") + ")";

		var $sel1 = $('#tr_quaObjectsCount,#tr_quaStorageSize');
		var $sel2 = $('#tr_quaEmpty');

		if(status.qTotalObjects > 0)
		{
			$sel1.show();
			$sel2.hide();
			setText("value_quarantine_0", status.qTotalObjects + '');
			qnb_setupSize(status.qStorageSize,
				$('#qStorageSize'),
				$('#qStorageSizeUnits'));
		}
		else
		{
			$sel1.hide();
			$sel2.show();
		}
	}
}

// object to get & store summary info
var summaryListFunc=new Array();
summaryListFunc.summary={
	rtp        : {status_id:0},
	update     : {status_id:0},
	license    : {status_id:0},
	quarantine : {status_id:0,count_new:0}
};
summaryListFunc.onGetSummary=function(resp){}
summaryListFunc.isSummary=function(){return window.location.hash=='#summary'}

summaryListFunc.updateSummary=function()
{
	paintStatusComponentRTP(this.summary.rtp);
	paintStatusComponentUpdate(this.summary.update)
	paintStatusComponentLicense(this.summary.license);
	paintStatusComponentQuarantine(this.summary.quarantine);
}

summaryListFunc.response = null;
summaryListFunc.requestActive = false;

function summary_draw()
{
	if(summaryListFunc.requestActive === true)
		return;

	summaryListFunc.rtpSum(summaryListFunc.response.rtp);
	summaryListFunc.summary.license = summaryListFunc.response.license;
// 	summaryListFunc.addProp(
// 		summaryListFunc.summary.license,
// 		summaryListFunc.response.license);

	summaryListFunc.summary.license.status_id =
		getStatusComponentPaintLicense(summaryListFunc.summary.license)
			.status_id;

	summaryListFunc.quaSum(summaryListFunc.response.qinfo);
	summaryListFunc.updSum(summaryListFunc.response.update);

	if(summaryListFunc.isSummary())
		summaryListFunc.updateSummary();

	summaryListFunc.onGetSummary(summaryListFunc.summary);
}

function summary_handleResponse(response)
{
	summaryListFunc.requestActive = false;

	if(!ic.ajaxError(response))
	{
		summaryListFunc.response = response;
		summary_draw();
	}
}

summaryListFunc.run = function()
{
	if(summaryListFunc.requestActive === false)
	{
		summaryListFunc.requestActive = true;
		ic.getSummary(summary_handleResponse)
	}
}

summaryListFunc.rtpSum = function(resp)
{
	summaryListFunc.summary.rtp = resp;
	summaryListFunc.summary.rtp.status_id=getStatusComponentPaintRTP(summaryListFunc.summary.rtp).status_id;
}

summaryListFunc.quaSum = function(resp)
{
	summaryListFunc.summary.quarantine = resp;
}

summaryListFunc.updSum = function(resp)
{
	if(!resp)
		return;
	summaryListFunc.summary.update = resp;
	if(resp.current_bases_state!==undefined)
		summaryListFunc.summary.update.status_id=getStatusComponentPaintUpdate(resp.current_bases_state).status_id;
}

function summaryPage_hideInfoElements()
{
	[	'table_rtp',
		'table_update',
		'tr_quaObjectsCount',
		'tr_quaStorageSize',
		'tr_quaEmpty',
		'tr_licenseStatusLabel',
		'tr_licenseExpires',
		'tr_licenseDaysRemains'
	].each(function(val){ $('#' + val).hide() })
}

ic.registerConnectionErrorHandler(function(){
	if( $('#summaryPageMarker').length > 0 )
	{
		$('#view_data .connActive').hide();
		$('#view_data .connLost').show();
		$('#view_data a:visible').disable();
	}
})

ic.registerConnectionRestoredHandler(function(){
	if( $('#summaryPageMarker').length > 0 )
	{
		$('#view_data .connActive').show();
		$('#view_data .connLost').hide();
		$('#view_data a:visible').enable();
	}
})
