TASK_RTP = 0
TASK_ODS = 1
TASK_UPDATE = 2

COMMAND_START_TASK = 0
COMMAND_STOP_TASK = 1
COMMAND_PAUSE_TASK = 2
COMMAND_RESUME_TASK = 3

FSTYPE_LOCAL 				= 1
FSTYPE_MOUNTED 				= 2
FSTYPE_SHARED 				= 3
FSTYPE_ALLREMOTELYMOUNTED 	= 4
FSTYPE_ALLSHARED 			= 5

FSNAME_ANY 		= 0
FSNAME_EXT2 	= 1
FSNAME_EXT3 	= 2
FSNAME_REISERFS = 3
FSNAME_UFS 		= 4
FSNAME_SAMBA 	= 5
FSNAME_NFS 		= 6

OAS_ACCESSTYPE_SMARTCHECK		= 1
OAS_ACCESSTYPE_OPEN 			= 2
OAS_ACCESSTYPE_OPEN_AND_MODIFY 	= 3
OAS_ACCESSTYPE_EXECUTE 			= 4

OAS_ACTION_CURE 		= 1
OAS_ACTION_REMOVE		= 2
OAS_ACTION_RECOMMENDED	= 3
OAS_ACTION_QUARANTINE	= 4
OAS_ACTION_SKIP		= 5

SCAN_TYPE_ALLOBJECTS 	= 1
SCAN_TYPE_BY_FORMAT   	= 2
SCAN_TYPE_BY_EXTENSION 	= 3
SCAN_TYPE_BY_MASK	 	= 4
	 
VERDICT_TYPE_UNDEFINED 		= 0
VERDICT_TYPE_VIRWARE 		= 1
VERDICT_TYPE_TROJWARE 		= 2
VERDICT_TYPE_MALWARE 		= 3
VERDICT_TYPE_ADWARE 		= 4
VERDICT_TYPE_PORNWARE 		= 5
VERDICT_TYPE_RISKWARE 		= 6
VERDICT_TYPE_VULNERABILITY 	= 7
VERDICT_TYPE_XFILES 		= 8
VERDICT_TYPE_SOFTWARE 		= 9

SCH_START_RULETYPE_UNKNOWN 		= 0
SCH_START_RULETYPE_TIME 		= 1
SCH_START_RULETYPE_BASES_RELOAD = 2
SCH_START_RULETYPE_STARTUP 		= 3

SCH_STOP_RULETYPE_UNKNOWN 			= 0
SCH_STOP_RULETYPE_DURATION_LIMIT	= 1
SCH_STOP_RULETYPE_DURATION_INTERVAL	= 2
SCH_STOP_RULETYPE_TIME_INTERVAL		= 3
SCH_STOP_RULETYPE_BASES_RELOAD 		= 4

SCH_SUSPEND_RULETYPE_UNKNOWN 			= 0
SCH_SUSPEND_RULETYPE_DURATION_LIMIT		= 1
SCH_SUSPEND_RULETYPE_DURATION_INTERVAL	= 2
SCH_SUSPEND_RULETYPE_TIME_INTERVAL		= 3

SCH_DAY_TYPE_UNKNOWN 		= 0
SCH_DAY_TYPE_DAY_OF_MONTH 	= 1
SCH_DAY_TYPE_DAY_OF_WEEK 	= 2

SCH_MONTH_JAN = 1
SCH_MONTH_FEB = 2 
SCH_MONTH_MAR = 3
SCH_MONTH_APR = 4
SCH_MONTH_MAY = 5 
SCH_MONTH_JUN = 6
SCH_MONTH_JUL = 7
SCH_MONTH_AUG = 8
SCH_MONTH_SEP = 9 
SCH_MONTH_OCT = 10
SCH_MONTH_NOV = 11
SCH_MONTH_DEC = 12

SCH_WEEK_DAY_MON = 1
SCH_WEEK_DAY_TUE = 2
SCH_WEEK_DAY_WED = 3
SCH_WEEK_DAY_THU = 4
SCH_WEEK_DAY_FRI = 5
SCH_WEEK_DAY_SAT = 6
SCH_WEEK_DAY_SUN = 7
SCH_WEEK_DAY_WRK = 8
SCH_WEEK_DAY_WND = 9

SCH_RULE_TYPE_START 	= 0
SCH_RULE_TYPE_STOP 		= 1
SCH_RULE_TYPE_SUSPEND 	= 2

SCH_TIME_INTERVAL_DAYS 			= 0
SCH_TIME_INTERVAL_MONTH 		= 1
SCH_TIME_INTERVAL_WEEK 			= 2

PROXY_AUTH_TYPE_NOTREQUIRED	 			= 0
PROXY_AUTH_TYPE_NTLM		 			= 1
PROXY_AUTH_TYPE_PLAIN		 			= 2
PROXY_AUTH_TYPE_NTLM_WITH_CREDENIALS	= 3

UPDATE_TYPE_UNDEFINED 						= 0
UPDATE_TYPE_ALL_BASES 						= 1
UPDATE_TYPE_MODULES 						= 2
UPDATE_TYPE_RETRANSLATE_COMPONENT_LIST 		= 3
UPDATE_TYPE_RETRANSLATE_PRODUCT_COMPONENTS 	= 4
UPDATE_TYPE_RETRANSLATE_ALL_COMPONENTS 		= 5

UPDATE_SOURCE_TYPE_AKSERVER = 1
UPDATE_SOURCE_TYPE_KLSERVER = 2
UPDATE_SOURCE_TYPE_CUSTOM 	= 3

UPDATE_ACTION_DOWNLOAD_APPLY = 2

function convertIntToChar2(val){
	var result = "0"
	if (val>9) result= val
	else result+= val
	return result 

}

function getSchMonthDescription(month){
	switch (month) {
		case SCH_MONTH_JAN : return "SCH_JAN"
		case SCH_MONTH_FEB : return "SCH_FEB" 
		case SCH_MONTH_MAR : return "SCH_MAR"
		case SCH_MONTH_APR : return "SCH_APR"
		case SCH_MONTH_MAY : return "SCH_MAY"
		case SCH_MONTH_JUN : return "SCH_JUN"
		case SCH_MONTH_JUL : return "SCH_JUL"
		case SCH_MONTH_AUG : return "SCH_AUG"
		case SCH_MONTH_SEP : return "SCH_SEP"
		case SCH_MONTH_OCT : return "SCH_OCT"
		case SCH_MONTH_NOV : return "SCH_NOV"
		case SCH_MONTH_DEC : return "SCH_DEC"
		default : return ""
	}	
}

function getSchWeekDayDescription(week_day){
	switch(week_day) {
		case SCH_WEEK_DAY_MON : return "SCH_MON"
		case SCH_WEEK_DAY_TUE : return "SCH_TUE"
		case SCH_WEEK_DAY_WED : return "SCH_WED"
		case SCH_WEEK_DAY_THU : return "SCH_THU"
		case SCH_WEEK_DAY_FRI : return "SCH_FRI"
		case SCH_WEEK_DAY_SAT : return "SCH_SAT"
		case SCH_WEEK_DAY_SUN : return "SCH_SUN"
		case SCH_WEEK_DAY_WRK : return "SCH_WORKDAYS"
		case SCH_WEEK_DAY_WND : return "SCH_WEEKEND"
	}

}