/*  
 * $Id:
 *
 * This source file is a part of a Kaspersky Antivirus For Samba Servers.
 * Copyright (C) Kaspersky Lab, 1997-2004
 * See License.txt for details
 *
 */

#ifndef __KAV_SAMBA_COMMON__
#define __KAV_SAMBA_COMMON__

#include "oas/small/protocol.h"

typedef struct
{
	int				sock;
	u_int8_t 		check_result;
	int				flags;
	int				written;
	char* 			filename;
	u_int8_t 		file_result;
	time_t			last_open;
	u_int8_t		dir_in_open;
} samba_conn;

int kav_connect();
int kav_disconnect();
int kav_connected();

enum FileAccessType kav_check_file(const char * filename, enum FileOpType, int flags, dev_t, ino_t);
enum FileAccessType kav_notify_file(const char * filename, enum FileNotifyType, dev_t, ino_t);
void samba_file_checked(void*, const CheckFileResultInfoData*);
void init_stuff();

extern samba_conn 		  daemon_connect;
extern connection_struct	* smbd_connect;

#define smb_default_sock "/var/run/kav4fs-samba"

#endif
